'use strict';

var CL = typeof module != 'undefined' ? require('../coastline') : window.CL;

CL.run(function* () {
	
	var start = Date.now();
	
	var print = function* (timeout, text) {
		yield CL.sleep(timeout);
		console.log(Math.round((Date.now() - start) / 500) * 500, text);
	};
	
	console.log('start');
	
	yield CL.run(function* () {
		
		yield print(1000, 'foreground 1');
		
		CL.bg(print(500, '-- background 1'));
		CL.bg(print(1500, '-- background 2'));
		CL.bg(print(3000, '-- background 3'));
		CL.bg(print(4500, '-- background 4'));
		
		yield print(1000, 'foreground 2');
		
		CL.bg(print(0, '-- background 5'));
		
		yield print(1000, 'foreground 3');
		
	});
	
	yield CL.run(function* () {
		CL.bg(print(1500, '-- background a'));
		var b = CL.bg(print(1000, '-- background b'));
		CL.bg(print(500, '-- background c'));
		yield b;
		console.log('foreground after b');
	});
	
	console.log('end');
	
});