var CL = require('coastline');

var sleep = function* () {
	yield setTimeout(CL.done(), 100);
};
var print = function (x, obj, msg) {
	console.log(Date.now() + ' ' + '  '.repeat(3 - x) + ' ' + obj.tag + ' ' + msg);
};
var a = {
	start: CL(function* (x) {
		yield sleep();
		print(x, this, 'start');
		yield b.continue(this, x);
	}),
	decr: CL(function* (x) {
		yield sleep();
		print(x, this, 'decr');
		yield b.continue(this, x - 1);
		print(x, this, x);
	}),
	finish: CL(function* (x) {
		yield sleep();
		print(x, this, 'finish');
	})
};
var b = {
	continue: CL(function* (a, x) {
		yield sleep();
		print(x, this, x);
		if (x) yield a.decr(x);
		else yield a.finish(x);
	})
};

var a1 = Object.create(a);
var a2 = Object.create(a);

a1.tag = 'a1';
a2.tag = 'a2';
b.tag = 'b';

a1.start(3);
a1.start(3);
a2.start(3);