'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	/*
		This tests that CL function does the correct thing depending on the argument.
	 */
	 
	CLT.eq(typeof CL(function () {}), 'function');
	CLT.eq(typeof CL(function* () {}), 'function');
	
	var obj = {};
	var c = CL(obj);
	CLT.assert(c instanceof CL.Context);
	CLT.eq(obj[CL.key], c);
	
	CLT.assert(CL() instanceof CL.Context);
	
	return CLT.success;
	
});