'use strict';

var CLT = require('../test');
var CL = CLT.CL; 

module.exports = CL.run(function* () {
	
	/*
		Map is iterable, but not an iterator. Must fall through.
	 */
	var map = new Map();
	CLT.eq((yield map), map);
	
	/*
		Generator is both iterator and iterable. Must be evaluated.
	 */
	var gen = function* () {
		return true
	};
	CLT.eq((yield gen()), true);
	
	return CLT.success;
	
});