'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var sum = 0;
	var arr = [0, 1, 2, 3, 4];
	
	var resArr = yield CL.map(arr, function* (v, i) {
		return sum += v;
	});
	
	CLT.eq(resArr, [0, 1, 3, 6, 10]);
	CLT.eq(sum, 10);
	
	var obj = {
		five: 5,
		four: 4,
		three: 3,
		two: 2,
		one: 1
	};
	
	var resObj = yield CL.map(obj, function* (v, k) {
		return v;
	});
	
	CLT.eq(resObj, {'five': 5, 'four': 4, 'three': 3, 'two': 2, 'one': 1});
	
	return CLT.success;
	
});