'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var arr = [0, 1, 2, 3, 4];
	
	var resArr = yield CL.mapParallel(arr, function* (v, i) {
		yield CL.sleep(v * 100);
		return v * i;
	});
	
	CLT.eq(resArr, [0, 1, 4, 9, 16]);
	
	var obj = {
		five: 5,
		four: 4,
		three: 3,
		two: 2,
		one: 1
	};
	
	var resObj = yield CL.mapParallel(obj, CL.fun(function* (v, k) {
		yield CL.sleep(v * 100);
		return v;
	}));
	
	CLT.eq(resObj, { five: 5, four: 4, three: 3, two: 2, one: 1 });
	
	return CLT.success;
	
});