'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var ctor = function () {
		this.init();
	}
	ctor.prototype = {
		init: CL.fun(function* () {
			yield CL.sleep(100);
			this.ok = 'ok';
		})
	};
	
	var obj = yield CL.wait(new ctor());
	CLT.eq(obj.ok, 'ok');
	
	return CLT.success;
	
});
