var CL = require('coastline');

var DemoClass = function () {
	this.print = CL(function* (wat) {
		yield setTimeout(CL.done(), 1000);
		console.log(Date.now(), wat);
	})
};

var common = new DemoClass();
var a = new DemoClass();
var b = new DemoClass();

CL.run(function* () {
	yield common.print('a common one');
	yield a.print('a own one');
	yield a.print('a own two');
	yield common.print('a common two');
});
CL.run(function* () {
	yield common.print('b common one');
	yield b.print('b own one');
	yield b.print('b own two');
	yield common.print('b common two');
});