'use strict';

var CLT = require('../test');
var CL = CLT.CL;
var fs = require('fs');

module.exports = CL.run(function* () {

	var res = '';
	
	var priofun = function* (p, c) {
		CL.priority(p);
		yield;
		res += c;
	}
	
	CL.bg(priofun, -5, 'z');
	CL.bg(priofun, 5, 'a');
	CL.bg(priofun, -4, 'y');
	CL.bg(priofun, 4, 'b');
	CL.bg(priofun, -3, 'x');
	CL.bg(priofun, 3, 'c');
	
	yield CL.sleep(100);
	
	CLT.eq(res, 'abcxyz');
	
	return CLT.success;
	
}); 
