'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	var gen = function* () {
		return 'gen';
	};
	
	CLT.eq(yield gen, 'gen');
	CLT.eq(yield gen(), 'gen');
	
	CLT.eq(yield function* () {
		return yield gen;
	}, 'gen');
	CLT.eq(yield function* () {
		return yield gen();
	}, 'gen');
	
	CLT.eq(yield function* () {
		yield gen;
	}, undefined);
	CLT.eq(yield function* () {
		yield gen();
	}, undefined);
	
	CLT.eq(yield function* () {
		return gen;
	}, gen);
	var gengen = gen();
	CLT.eq(yield function* () {
		return gengen;
	}, gengen);
	
	return CLT.success;
	
});