'use strict';

var CLT = require('../test');
var CL = CLT.CL;

module.exports = CL.run(function* () {
	
	CLT.eq(123, yield CL.top(function* () {
		return 123;
	}));
	
	var fail;
	
	fail = null;
	yield CL.try(function* () {
		yield CL.top(function* () {
			CL.throw('fail');
		});
	}, function (e) {
		fail = e.type;
	});
	CLT.eq(fail, 'fail');
	
	fail = null;
	yield CL.try(function* () {
		yield CL.top(function* () {
			CL.sleep(100);
			CL.throw('fail');
		});
	}, function (e) {
		fail = e.type;
	});
	CLT.eq(fail, 'fail');
	
	return CLT.success;
	
});